//
//Author			: walk.ly  
//Time			: 2009-05-08
//Version		: 1.0.0
//Description	: ˮ׼ƽϰ 	
//

#ifndef __LEVEL_SURV_
#define __LEVEL_SURV_

#ifdef _VS_WALK
#include "wkClassDefine.h"
#endif

#include "˫.cpp"


int dec=3;	//ЧСλ

array ptNames;	//̵߳
array pws;		//Ȩ=վ
array obs;		//۲ֵ
array vs;		//
array Hs;		//ֵ߳

double bgnH;	//ֵ߳
double endH;	//յֵ߳

double f, fa;	//պϲݲ

bool CalHClose()
{
	f=Sum(obs)-(endH-bgnH);

	//
	fa=0.012*sqrt(Sum(pws));
	if (abs(f)>fa)
	{
		string msg;
		msg.format("պϲ=%lf, =%lf\n!", f, fa);
		message(msg);
		return false;
	}
	return true;
}

bool AdjError()
{
	double powerSm=Sum(pws);
	for (int i=0; i<pws.getSize(); i++)
	{
		double p=pws[i];
		double v=-f*p/powerSm;
		vs.add(round5(v, dec));//decλ
	}

	//*** 
	double fr=(Sum(vs)+f);
	AdjRoundError(pws, vs, fr, dec);

	//֤
	double sumV=Sum(vs);
	if (abs(f+sumV)>1e-6)
	{
		string msg;
		msg.format("պϲ=%lf, =%lf\nӦֵ!", f, fa);
		message(msg);
		return false;
	}
	return true;
}

bool CalH()
{
	Hs.add(bgnH);
	for (int i=0; i<vs.getSize(); i++)
	{
		double h=Hs[i], o=obs[i], v=vs[i];
		Hs.add(h+o+v);
	}

	//֤յ߳
	double H=Hs[i];
	if (abs(H-endH)>1e-6)
	{
		string msg;
		msg.format("յ%s: H=%lf, ֪H=%lf\nֵ!", ptNames[i], H, endH);
		message(msg);
		return false;
	}
	return true;
}

void Output()
{
	string fileName="c:\\levelRes.txt";
	wkFile fp;
	fp.open(fileName, "wt");

	string msg;
	msg="|=====================================================|\n"; fp.puts(msg);
	msg="|    | վ | ۲ֵ |  |  ߲  |  ߳  |\n"; fp.puts(msg);
	msg="|--------|--------|--------|--------|--------|--------|\n"; fp.puts(msg);
	int n=Hs.getSize();
	for (int i=0; i<n; i++)
	{
		string m="--------";
		msg.format("|%6s  |%s|%s|%s|%s|%8.3lf|\n", ptNames[i], m, m, m, m, Hs[i]);
		fp.puts(msg);
		if (i<n-1)
		{
			double o=obs[i], v=vs[i];
			msg.format("|%s|%6d  |%7.3lf |%7.0lf |%7.3lf |%s|\n",
						m, pws[i], o, v*1000.0, o+v, m);
		}else
		{
			msg="|--------|--------|--------|--------|--------|--------|\n"; fp.puts(msg);
			msg.format("|  ϼ  |%6.0lf  |%7.3lf |%7.0lf |%7.3lf |        |\n",
						Sum(pws), Sum(obs), Sum(vs)*1000.0, Sum(obs)+Sum(vs));
		}
		fp.puts(msg);
	}
	msg=       "|-----------------------------------------------------|\n"; fp.puts(msg);
	msg.format("|     պϲ f  =%6.0lf mm                            |\n", f*1000.0); fp.puts(msg);
	msg.format("| պϲ f=%6.0lf mm                            |\n", fa*1000.0); fp.puts(msg);
	msg=       "|            f<fݣ۲ɹ淶Ҫ󣬿ƽ    |\n"; fp.puts(msg);
	msg=       "| עθ = -(վ * պϲ / վ)      |\n"; fp.puts(msg);
	msg=       "|=====================================================|\n"; fp.puts(msg);
	fp.close();

	//ʹü±ʾ
	wkView view;
	view.shell("notepad "+fileName);
}

//ƽ
void Adjustment()
{
	//պϲ
	if (!CalHClose())
		return;

	//
	if (!AdjError())
		return;

	//߳
	if (!CalH())
		return;

	//
	Output();
}

#endif //__LEVEL_SURV_
